<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2004 Shitworks                                            |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | aloe: an event management addon for Ian Berry's Cacti	           |
 +-------------------------------------------------------------------------+
 | Any questions or comments regarding this code should be directed to:    |              
 | - sidewinder at shitworks.com                                           |
 +-------------------------------------------------------------------------+
 |                                                                         |
 +-------------------------------------------------------------------------+
*/

include ("./include/auth.php");
include ('./aloe/aloe-config.php');
include ('./aloe/aloe-db.php');

global $sql_where, $hostfilter;


/* set default action */
	if (!isset($_REQUEST["action"])) { $_REQUEST["action"] = ""; }


	/* remember these search fields in session vars so we don't have to keep passing them around */
	if (isset($_REQUEST["page"])) {
		$_SESSION["sess_current_page"] = $_REQUEST["page"];
	}elseif (isset($_SESSION["sess_current_page"])) {
		$_REQUEST["page"] = $_SESSION["sess_current_page"];
	}else{
		$_REQUEST["page"] = "1"; /* default value */
	}
	
	if (isset($_REQUEST["filter"])) {
		$_SESSION["sess_filter"] = $_REQUEST["filter"];
	}elseif (isset($_SESSION["sess_filter"])) {
		$_REQUEST["filter"] = $_SESSION["sess_filter"];
	}else{
		$_REQUEST["filter"] = ""; /* default value */
	}
	
	if (isset($_REQUEST["host"])) {
		$_SESSION["sess_host"] = $_REQUEST["host"];
	}elseif (isset($_SESSION["sess_host"])) {
		$_REQUEST["host"] = $_SESSION["sess_host"];
	}else{
		$_REQUEST["host"][0] = "0"; /* default value */
	}

	if (isset($_REQUEST["date"])) {
		$_SESSION["sess_date"] = $_REQUEST["date"];
	}elseif (isset($_SESSION["sess_date"])) {
		$_REQUEST["date"] = $_SESSION["sess_date"];
	}else{
		$_REQUEST["date"] = ""; /* default value */

	}

	if (isset($_REQUEST["end_date"])) {
		$_SESSION["sess_end_date"] = $_REQUEST["end_date"];
	}elseif (isset($_SESSION["sess_end_date"])) {
		$_REQUEST["end_date"] = $_SESSION["sess_end_date"];
	}else{
		$_REQUEST["end_date"] = ""; /* default value */

	}

	if (isset($_REQUEST["efacility"])) {
		$_SESSION["sess_efacility"] = $_REQUEST["efacility"];
	}elseif (isset($_SESSION["sess_efacility"])) {
		$_REQUEST["efacility"] = $_SESSION["sess_efacility"];
	}else{
		$_REQUEST["efacility"] = ""; /* default value */

	}

	if (isset($_REQUEST["elevel"])) {
		$_SESSION["sess_elevel"] = $_REQUEST["elevel"];
	}elseif (isset($_SESSION["sess_elevel"])) {
		$_REQUEST["elevel"] = $_SESSION["sess_elevel"];
	}else{
		$_REQUEST["elevel"] = ""; /* default value */

	}


	if (isset($_REQUEST["output"])) {
		$_SESSION["sess_output"] = $_REQUEST["output"];
	}elseif (isset($_SESSION["sess_output"])) {
		$_REQUEST["output"] = $_SESSION["sess_output"];
	}else{
		$_REQUEST["output"] = "screen"; /* default value */

	}



switch ($_REQUEST["output"]) {

	case 'file' :

		export();
		break;


	default:
		include_once("./aloe/top_aloe_header.php");
		
		messages();
		
		include_once("./include/bottom_footer.php");
		break;
}


function aloe_row_color($row_color1, $row_color2, $row_value, $level) {

	global $aloe_colors;


	switch ($level) {

		case (strncasecmp($level,'Emergency',3)) :

			$current_color = $aloe_colors["Emergency"];
			break;

		case (strncasecmp($level,'Critical',3)) :

			$current_color = $aloe_colors["Critical"];
			break;

		case (strncasecmp($level,'Alert',3)) :

			$current_color = $aloe_colors["Alert"];
			break;

		case (strncasecmp($level,'Error',3)) :

			$current_color = $aloe_colors["Error"];
			break;

		case (strncasecmp($level,'Warning',3)) :

			$current_color = $aloe_colors["Warning"];
			break;
	
		default :
		
			if (($row_value % 2) == 1) {
				$current_color = $row_color1;
			}else{
				$current_color = $row_color2;
			}
	
	} // switch

	print "<tr bgcolor='#$current_color'>\n";
	
	return $current_color;
}

function sql_hosts_where() {

global $hostfilter, $aloe_config;


	if (!empty($_REQUEST["host"])) {

		$hostfilter  = "";

		$x=0;

		if ($_REQUEST["host"][$x] != "0") {

		while ($x < count($_REQUEST["host"]))
		{

			if (!empty($hostfilter)) {

				$hostfilter .= " or " . $aloe_config["hostField"] . "='" . $_REQUEST["host"][$x] . "'";

			} else { 

				if (!empty($sql_where)) {
	
					$hostfilter .= " and " . $aloe_config["hostField"] . "='" . $_REQUEST["host"][$x] . "'";

				} else {

					$hostfilter .= "  (" . $aloe_config["hostField"] . "='" . $_REQUEST["host"][$x] . "'";

				}

			}

		   $x++;

		} //while

		$hostfilter .= ")";

		} // if 
	}

}


function get_messages() {

global $sql_where, $hostfilter, $aloe_config;


	$sql_where = "";


	/* form the 'where' clause for our main sql query */


	if (!empty($_REQUEST["host"])) {

		sql_hosts_where();

		if (!empty($hostfilter)) {

			$sql_where .=  "where " . $hostfilter;
		}

	}

	if (!empty($_REQUEST["date"])) {
		if (!empty($sql_where)) {

			$sql_where .= " and " . $aloe_config["dateField"] . " <='" . $_REQUEST["date"] . "'";
		} else {
	
			$sql_where .= " where " . $aloe_config["dateField"] . " <='" . $_REQUEST["date"] . "'";
		}
	}



	if (!empty($_REQUEST["end_date"])) {
		if (!empty($sql_where)) {

			$sql_where .= " and " . $aloe_config["dateField"] . " >='" . $_REQUEST["end_date"] . "'";
		} else {
	
			$sql_where .= " where " . $aloe_config["dateField"] . " >='" . $_REQUEST["end_date"] . "'";
		}
	}


	if (!empty($_REQUEST["filter"])) {
		if (!empty($sql_where)) {

			$sql_where .= " and " . $aloe_config["textField"] . " like '%%" . $_REQUEST["filter"] . "%%'";
		} else {
			$sql_where .= " where " . $aloe_config["textField"] . " like '%%" . $_REQUEST["filter"] . "%%'";
		}
	}


	if (!empty($_REQUEST["efacility"])) {
		if (!empty($sql_where)) {

			$sql_where .= " and " . $aloe_config["facilityField"] . " ='" . $_REQUEST["efacility"] . "'";
		} else {
	
			$sql_where .= " where " . $aloe_config["facilityField"] . " ='" . $_REQUEST["efacility"] . "'";
		}
	}


	if (!empty($_REQUEST["elevel"])) {
		if (!empty($sql_where)) {

			$sql_where .= " and " . $aloe_config["priorityField"] . " ='" . $_REQUEST["elevel"] . "'";
		} else {
	
			$sql_where .= " where " . $aloe_config["priorityField"] . " ='" . $_REQUEST["elevel"] . "'";
		}
	}

	 if ($_REQUEST["output"] != "file") {

		$limit = " LIMIT " . (read_config_option("num_rows_data_source")*($_REQUEST["page"]-1)) . "," . read_config_option("num_rows_data_source");

	 } else { $limit = ""; }


	$messages = sdb_fetch_assoc("SELECT " .
				$aloe_config["hostField"] . "," .
				$aloe_config["priorityField"] . "," .
				$aloe_config["facilityField"] . "," .
				$aloe_config["dateField"] . "," .
				$aloe_config["timeField"] . "," .
				$aloe_config["textField"] .
				" FROM " . $aloe_config["aloeTable"] . " " .
				$sql_where . " " .
				" ORDER BY " . $aloe_config["dateField"] . " DESC," . $aloe_config["timeField"] . " DESC" . $limit);

	return($messages);

}


function export () {

	global $aloe_config;


		header("Content-type: text/plain");
		header("Content-Disposition: attachment; filename=log_view-" . date("Y-m-d",time()) . ".log");

		$messages = get_messages();

		if (sizeof($messages) > 0) {
			foreach ($messages as $message) {

				print $message[$aloe_config["hostField"]] . "," . $message[$aloe_config["facilityField"]] . "," . $message[$aloe_config["priorityField"]] . "," . $message[$aloe_config["dateField"]] . "," . $message[$aloe_config["timeField"]] . "," . $message[$aloe_config["textField"]] . "\r\n";

			}
		}

}


function messages() {

	global $colors, $ds_actions, $sql_where, $hostfilter, $aloe_config;

	?>

	<table width="100%" cellspacing="0" cellpadding="0">
	<form name="form_graph_id">

	<tr>
		<td bgcolor="#f5f5f5" colspan="1" height="8" width="135" style="background-image: url(images/shadow_gray.gif); background-repeat: repeat-x; border-right: #aaaaaa 1px solid;">
			<img src="images/transparent_line.gif" width="135" height="2" border="0"><br>
		</td>
		<td colspan="2" height="8" style="background-image: url(images/shadow.gif); background-repeat: repeat-x;" bgcolor="#ffffff">
			
		</td>
	</tr>


	<tr height="5">
		<td valign="top" rowspan="2" width="10%" style="padding: 1px; border-right: #aaaaaa 1px solid;" bgcolor='#f5f5f5'>
			<table bgcolor="#f5f5f5" width="100%" cellpadding="1" cellspacing="0" border="0">

		</td>
	</tr>

	<?php
	start_box("<strong>Output To</strong>", "98%", $colors["header"], "3", "center", "");
	?>

					<td>




						<select name="output">
							<option value="screen" selected>Screen &nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp</option>
							<option value="file" <?php if ($_REQUEST["output"] == "file") {?> selected<?php }?>>File &nbsp</option>
						</select>

					</td>
	
				</table>
			</td>
		</tr>
	</table>

	<br>

						<select name="host[]" multiple size="25">
							<option value="0"<?php if ($_REQUEST["host"][0] == "0") {?> selected<?php }?>>show all hosts &nbsp&nbsp</option>
							
							<?php

							$hosts = sdb_fetch_assoc("SELECT DISTINCT " . $aloe_config["hostField"] . " FROM " . $aloe_config["aloeTable"] . " ORDER BY " . $aloe_config["hostField"] . " ASC");
							
							if (sizeof($hosts) > 0) {

								foreach ($hosts as $host) {

									print "<option value=" . $host[$aloe_config["hostField"]];
									foreach ($_REQUEST["host"] as $rh) {
										if ($rh == $host[$aloe_config["hostField"]]) { 
											print " selected ";
											break;
										} 
									}

									print ">";
									print $host[$aloe_config["hostField"]] . "</option>\n";

								}
							}


							?>
							
						</select>
			

		<td width="135" height="500"></td>
		<td width="100%" valign="top"><?php display_output_messages();?>



	<?php

	$messages = get_messages();


	$filterdate = sdb_fetch_row("select distinct " . $aloe_config["dateField"] . "from ". $aloe_config["aloeTable"] . " where " . $aloe_config["dateField"] . "='" . $_REQUEST["date"] . "'");

	start_box("<strong>aloe Message Filters</strong>[<font size=1> $sql_where </font>]", "98%", $colors["header"], "3", "center", "");
	?>

	<tr bgcolor="<?php print $colors["panel"];?>">

		<td>
			<table width="100%" cellpadding="0" cellspacing="0">
				<tr>

					<td width="20">
						Beginning :&nbsp;
					</td>
					<td width="1">
						<select name="date">
							<option value="0"<?php if ($_REQUEST["date"] == "0") {?> selected<?php }?>>Any Date</option>
							
							<?php

							$dates = sdb_fetch_assoc("SELECT DISTINCT " . $aloe_config["dateField"] . " FROM " . $aloe_config["aloeTable"] . " ORDER BY " . $aloe_config["dateField"] . " DESC");
							
							if (sizeof($dates) > 0) {
							foreach ($dates as $date) {
								print "<option value=" . $date[$aloe_config["dateField"]]; if ($_REQUEST["date"] == $date[$aloe_config["dateField"]]) { print " selected"; } print ">" . $date[$aloe_config["dateField"]] . "</option>\n";
							}
							}


							?>
							
						</select>
					</td>


					<td width="10">&nbsp;</td>

					<td width="20">
						ending :&nbsp;
					</td>
					<td width="1">
						<select name="end_date">
							<option value="0"<?php if ($_REQUEST["end_date"] == "0") {?> selected<?php }?>>Any Date</option>
							
							<?php

							$dates = sdb_fetch_assoc("SELECT DISTINCT " . $aloe_config["dateField"] . " FROM " . $aloe_config["aloeTable"] . " ORDER BY " . $aloe_config["dateField"] . " DESC");
							
							if (sizeof($dates) > 0) {
							foreach ($dates as $date) {
								print "<option value=" . $date[$aloe_config["dateField"]]; if ($_REQUEST["end_date"] == $date[$aloe_config["dateField"]]) { print " selected"; } print ">" . $date[$aloe_config["dateField"]] . "</option>\n";
							}
							}


							?>
							
						</select>
					</td>


					<td width="30">&nbsp;</td>
					<td width="90" align="absmiddle">
						Search text :&nbsp;
					</td>
					<td width="1">
						<input type="text" name="filter" size="40" value="<?php print $_REQUEST["filter"];?>">
					</td>


					<td width="1">
						<select name="efacility">
							<option value="0"<?php if ($_REQUEST["efacility"] == "0") {?> selected<?php }?>>All Facilities</option>
							
							<?php

							$efacilities = sdb_fetch_assoc("SELECT DISTINCT " . $aloe_config["facilityField"] . " FROM " . $aloe_config["aloeTable"] . " WHERE " . $hostfilter . " ORDER BY " . $aloe_config["facilityField"] . " DESC");
							
							if (sizeof($efacilities) > 0) {
							foreach ($efacilities as $efacility) {
								print "<option value=" . $efacility[$aloe_config["facilityField"]]; if ($_REQUEST["efacility"] == $efacility[$aloe_config["facilityField"]]) { print " selected"; } print ">" . $efacility[$aloe_config["facilityField"]] . "</option>\n";
							}
							}


							?>
							
						</select>
					</td>


					<td width="1">
						<select name="elevel">
							<option value="0"<?php if ($_REQUEST["elevel"] == "0") {?> selected<?php }?>>All Priorities</option>
							
							<?php

							$elevels = sdb_fetch_assoc("SELECT DISTINCT " . $aloe_config["priorityField"] . " FROM " . $aloe_config["aloeTable"] . " WHERE " . $hostfilter . " ORDER BY " . $aloe_config["priorityField"] . " DESC");
							
							if (sizeof($elevels) > 0) {
							foreach ($elevels as $elevel) {
								print "<option value=" . $elevel[$aloe_config["priorityField"]]; if ($_REQUEST["elevel"] == $elevel[$aloe_config["priorityField"]]) { print " selected"; } print ">" . $elevel[$aloe_config["priorityField"]] . "</option>\n";
							}
							}


							?>
							
						</select>
					</td>

					<td>
						<input type="image" src="images/button_go.gif" alt="Go" border="0" align="right">
					</td>



				</tr>
			</table>
		</td>
		<input type='hidden' name='page' value='1'>
		</form>
	</tr>
	<?php
	end_box();
	?>


	<?php

	$total_rows = sdb_fetch_cell("SELECT count(*) from " . $aloe_config["aloeTable"] . " " . $sql_where);

	
	start_box("", "98%", $colors["header"], "3", "center", "");
	
	/* sometimes its a pain to browse throug a long list page by page... so make a list of each page #, so the
	user can jump straight to it */
	$page_number = 0; $url_page_select = "";


	$hostarray = "";
	foreach ($_REQUEST["host"] as $h) { $hostarray .= "host[]=$h&"; }

	$nav = "<tr bgcolor='#" . $colors["header"] . "'>
			<td colspan='6'>
				<table width='100%' cellspacing='0' cellpadding='0' border='0'>
					<tr>
						<td align='left' class='textHeaderDark'>
							<strong>&lt;&lt; "; if ($_REQUEST["page"] > 1) { $nav .= "<a class='linkOverDark' href='aloe.php?" . $hostarray . "date=" . $_REQUEST["date"] . "&end_date=" . $_REQUEST["end_date"] . "&filter=" . $_REQUEST["filter"] .  "&page=" . ($_REQUEST["page"]-1) . "'>"; } $nav .= "Previous"; if ($_REQUEST["page"] > 1) { $nav .= "</a>"; } $nav .= "</strong>
						</td>\n
						<td align='center' class='textHeaderDark'>
							Showing Rows " . ((read_config_option("num_rows_data_source")*($_REQUEST["page"]-1))+1) . " to " . ((($total_rows < read_config_option("num_rows_data_source")) || ($total_rows < (read_config_option("num_rows_data_source")*$_REQUEST["page"]))) ? $total_rows : (read_config_option("num_rows_data_source")*$_REQUEST["page"])) . " of $total_rows [$url_page_select]
						</td>\n
						<td align='right' class='textHeaderDark'>
							<strong>"; if (($_REQUEST["page"] * read_config_option("num_rows_data_source")) < $total_rows) { $nav .= "<a class='linkOverDark' href='aloe.php?" . $hostarray . "date=" . $_REQUEST["date"] . "&end_date=" . $_REQUEST["end_date"] . "&filter=" . $_REQUEST["filter"] .  "&page=" . ($_REQUEST["page"]+1) . "'>"; } $nav .= "Next"; if (($_REQUEST["page"] * read_config_option("num_rows_data_source")) < $total_rows) { $nav .= "</a>"; } $nav .= " &gt;&gt;</strong>
						</td>\n
					</tr>
				</table>
			</td>
		</tr>\n";
	
	print "	$nav
		<tr bgcolor='#" . $colors["header_panel"] . "'>
			<td class='textSubHeaderDark'>Host</td>
			<td class='textSubHeaderDark'>Date</td>
			<td class='textSubHeaderDark'>Time</td>
			<td class='textSubHeaderDark'>&nbsp;</td>
			<td class='textSubHeaderDark'>Message</td>
			<td class='textSubHeaderDark'>Level</td>
		</tr>\n";
	

	$i = 0;
	if (sizeof($messages) > 0) {
	foreach ($messages as $message) {
		aloe_row_color($colors["alternate"],$colors["light"],$i,$message[$aloe_config["priorityField"]]); $i++;
			?>
			<td nowrap>
				<?php print $message[$aloe_config["hostField"]];?>
			</td>

			<td nowrap>
				<?php print $message[$aloe_config["dateField"]];?>
			</td>
			<td nowrap>
				<?php print $message[$aloe_config["timeField"]];?>
			</td>
			<td nowrap>
				<?php print " ";?>
			</td>
			<td>
				<?php print $message[$aloe_config["textField"]];?>
			</td>
			<td nowrap>
				<?php print $message[$aloe_config["priorityField"]];?>
			</td>

		</tr>
		<?php
	}
		/* put the nav bar on the bottom as well */
		print $nav;
	}else{
		print "<tr><td><em>No Messages</em></td></tr>";
	}
	
	end_box(false);
	
	?>

	<input type='hidden' name='action' value='actions'>
	</form>

	<?php
}
?>
