<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2004 Ian Berry                                            |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | cacti: a php-based graphing solution                                    |
 +-------------------------------------------------------------------------+
 | Most of this code has been designed, written and is maintained by       |
 | Ian Berry. See about.php for specific developer credit. Any questions   |
 | or comments regarding this code should be directed to:                  |
 | - iberry@raxnet.net                                                     |
 +-------------------------------------------------------------------------+
 | - raXnet - http://www.raxnet.net/                                       |
 +-------------------------------------------------------------------------+
*/


function graph_print_xml($local_graph_id) {

global $config, $colors;

$xml_file = get_xml_data_source_path($local_graph_id);

if (file_exists($xml_file)) {

	include_once($config["library_path"] . "/xml.php");

	$fp = fopen($xml_file,"r");
	$xml_data = fread($fp,filesize($xml_file));
	fclose($fp);

	$xml = xml2array($xml_data);

}


if (isset($xml)) {
	print "<table width='98%' style='background-color: #f5f5f5; border: 1px solid #bbbbbb;' align='center' cellpadding='2'>";
	print "<tr bgcolor='#" . $colors["header_panel"] . "'>";

	foreach ($xml['displayfields'] as $displayfield) {

		if (isset($displayfield['colHeader'])) {

			print "<td class='textSubHeaderDark' align='center' colspan='" . sizeof($xml['displayfields']) . "'>" . $displayfield['colHeader'] . "</td> </tr>";
			print "<tr bgcolor='#" . $colors["header_panel"] . "'>";
			continue;

		}
			print "<td class='textSubHeaderDark' align='center' colspan='" . sizeof($displayfield['value']) . "'>" . $displayfield['heading'] . "</td>";

	}

		print "</tr>\n";


	foreach ($xml['displayfields'] as $displayfield) {

		if (isset($displayfield['colHeader'])) { continue; }

		if (is_array($displayfield['value'])) { 

			foreach ($displayfield['value'] as $displayvalue) {

				$j = 0;

				if (is_array($displayvalue)) { 

					print "<td align='center' bgcolor='". ($colors[$displayvalue['bgcolor']] ? $colors[$displayvalue['bgcolor']] : $displayvalue["Error"]) . "'>" . $displayvalue[$j] . "</td>";

					$j++;

				} else {
			
					print "<td align='center'>" . $displayvalue . "</td>";

				} // if is_array($displayvalue)

			}
			

		} else {

				print "<td nowrap align='center'>" . $displayfield['value'] . "</td>";
		}

	}

	print "</table>";
	print "<table width='98%' style='background-color: #ffffff; border: 1px solid #ffffff;' align='center' cellpadding='3'>";

}

} // function

?>